#include <gtk/gtk.h>
#include "gtkextendtreeview.h"

static GtkWidget* BuildExtendTreeView(){
  /* Creates an instance of the new widget */
  GtkExtendTreeView* const extend_tree = GTK_EXTEND_TREE_VIEW(gtk_extend_tree_view_new());
  /* Create a sample tree model */
  GtkListStore* const store = gtk_list_store_new(2,G_TYPE_STRING,G_TYPE_STRING);

  /* Set in the template two columns of example */
  GtkTreeView* const table = GTK_TREE_VIEW(extend_tree);
  gtk_tree_view_set_model(table,GTK_TREE_MODEL(store));
  /* Create a new GtkCellRendererText, add it to the tree view column */
  GtkCellRenderer* const renderer = gtk_cell_renderer_text_new();
  /* Create all the tree view columns needed to build the tree view model, and append them to the tree view */
  GtkTreeViewColumn *column = NULL;
  column = gtk_tree_view_column_new_with_attributes("First Column",renderer,"text",0,NULL);
  gtk_tree_view_append_column(table,column);
  column = gtk_tree_view_column_new_with_attributes("Second Column",renderer,"text",1,NULL);
  gtk_tree_view_append_column(table,column);

  /* Return the new widget */
  return GTK_WIDGET(extend_tree);
}

int main (int argc, char *argv[])
{
  GtkWidget *win = NULL;

  /* Initialize GTK+ */
  g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, (GLogFunc) gtk_false, NULL);
  gtk_init (&argc, &argv);
  g_log_set_handler ("Gtk", G_LOG_LEVEL_WARNING, g_log_default_handler, NULL);

  /* Create the main window */
  win = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_container_set_border_width (GTK_CONTAINER (win), 8);
  gtk_window_set_title (GTK_WINDOW (win), "Example to Extend Tree View");
  gtk_window_set_position (GTK_WINDOW (win), GTK_WIN_POS_CENTER);
  g_signal_connect (win, "destroy", gtk_main_quit, NULL);
  gtk_widget_set_size_request(GTK_WIDGET(win), 600,300);
  gtk_widget_realize (win);

  /* Creates an instance of the new widget and attach it to the window */
  gtk_container_add (GTK_CONTAINER (win), BuildExtendTreeView());

  /* Enter the main loop */
  gtk_widget_show_all (win);
  gtk_main ();
  return 0;
}
